Imports Microsoft.VisualBasic
Imports System
Imports System.IO
Imports System.Runtime.InteropServices

Public Class Module1

Public Declare Function FindMimeFromData Lib "urlmon.dll" ( _
ByVal pBC As IntPtr, _
<MarshalAs(UnmanagedType.LPWStr)> ByVal pwzUrl As String, _
<MarshalAs(UnmanagedType.LPArray, ArraySubType:=UnmanagedType.I1, SizeParamIndex:=3)> ByVal pBuffer As Byte(), _
ByVal cbSize As Integer, _
<MarshalAs(UnmanagedType.LPWStr)> ByVal pwzMimeProposed As String, _
ByVal dwMimeFlags As Integer, _
ByRef ppwzMimeOut As IntPtr, _
ByVal dwReserved As Integer) As Integer

Public Shared Function getMimeFromFile(ByVal file As String) As String
Dim mimeout As IntPtr

If Not System.IO.File.Exists(file) Then
  Throw New FileNotFoundException()
End If

Dim MaxContent As Integer=CInt(New FileInfo(file).Length)
If MaxContent>256 Then MaxContent=256

Dim fs As New FileStream(file,FileMode.Open)
Dim buf(MaxContent) As Byte
fs.Read(buf,0,MaxContent)
fs.Close()
Dim result As Integer=FindMimeFromData(IntPtr.Zero,file,buf,MaxContent,Nothing,0,mimeout,0)

If result<>0 Then
'Throw Marshal.GetHRForExceptionresult)
End If

Dim mime As String=Marshal.PtrToStringUni(mimeout)
Marshal.FreeCoTaskMem(mimeout)
Return mime
End Function 'getMimeFromFile

Public Shared Function Main(ByVal Args() As String) As Integer
Dim k As Integer
Dim mime As String

For Each Arg As String In Args
  Try
    mime=getMimeFromFile(Arg)
    Console.WriteLine(mime & vbTab & Arg) 
  Catch oExcept As Exception
    Console.WriteLine("?" & vbTab & Arg) 
    Console.Error.WriteLine("""" + Arg + """" + vbTab + oExcept.Message)
  End Try
Next

End Function 'Main

End Class 'Module1
